//modified:2002.02.21@20:20 by Alex

unit UnitMy;

interface

uses
  Registry;

type
  TMyRegistry = class(TRegistry)
    function ReadStringD(key:string;default:string):string;
    function ReadIntegerD(key:string;default:integer):integer;
    function ReadDateTimeD(key:string;default:TDateTime):TDateTime;
    function ReadFloatD(key:string;default:double):double;
    function ReadBoolean(key:string;default:boolean):boolean;
    procedure WriteBoolean(key:string;value:boolean);
  end;

implementation

////////////////////////////////////////////////////////////////////////////////
//////////////////////////////  MY REGISTRY  ///////////////////////////////////

function TMyRegistry.ReadStringD(key:string;default:string):string;
begin
  if ReadString(key)='' then
    result:=default
  else
    result:=ReadString(key);
end;

function TMyRegistry.ReadIntegerD(key:string;default:integer):integer;
begin
  if not ValueExists(key) then
    result:=default
  else
    try
      result:=ReadInteger(key);
    except
      result:=default;
    end;
end;

function TMyRegistry.ReadDateTimeD(key:string;default:TDateTime):TDateTime;
begin
  if not ValueExists(key) then
    result:=default
  else
    try
      result:=ReadDateTime(key);
    except
      result:=default;
    end;
end;

function TMyRegistry.ReadFloatD(key:string;default:double):double;
begin
  if not ValueExists(key) then
    result:=default
  else
    try
      result:=ReadFloat(key);
    except
      result:=default;
    end;
end;

function TMyRegistry.ReadBoolean(key:string;default:boolean):boolean;
begin
  if not ValueExists(key) then
    result:=default
  else
    try
      result:=(ReadString(key)='true') or (ReadString(key)='yes');
    except
      result:=default;
    end;
end;

procedure TMyRegistry.WriteBoolean(key:string;value:boolean);
begin
  if value then
    WriteString(key,'true')
  else
    WriteString(key,'false');
end;

//////////////////////////////  MY REGISTRY  ///////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

end.
